# -*- coding: utf-8 -*-
"""
Created on Fri Jan 24 16:09:16 2020

@author: Marie-Laure
"""

import pygame
import random
#----------Nos constantes----------
BLANC = (255, 255, 255)
NOIR = (0, 0, 0)
ECRAN_L = 800
ECRAN_H = 600    

#-------La classe Bloc: anneau et tête serpent ------------
class Bloc(pygame.sprite.Sprite):
    """cette classe représente un morceau du serpent """
    def __init__(self,x,y,monimage):
        super().__init__()
        #Création de l'image représentant le lutin. 
        self.image=monimage
        self.rect = self.image.get_rect()
        self.rect.x = x
        self.rect.y = y
#-------La classe Poussin ----------------------------------        
class Poussin(pygame.sprite.Sprite):
    """cette classe représente un poussin """
    def __init__(self):
        super().__init__()
        self.image = pygame.image.load("images/poussin.png").convert_alpha()
        self.rect = self.image.get_rect()
        self.rect.y = random.randrange(0, ECRAN_H)
        self.rect.x = random.randrange(0, ECRAN_L)
        
    def reset(self):
        """Changement de coordonnées lors d'une collision """
        self.rect.y = random.randrange(0, ECRAN_H)
        self.rect.x = random.randrange(0, ECRAN_L)
#-------Création d'un ou plusieurs anneaux -----------------------------
def creerAnneau(nb,xdepart,ydepart):
    for i in range(1,nb+1):
        x = xdepart - dep_x*i
        y = ydepart - dep_y*i
        anneau=Bloc(x,y,anneau_image)    
        #Ajouter le bloc à nos trois listes de lutins
        queue.append(anneau) #les anneaux du serpent
        lesAnneaux.add(anneau) #les anneaux pour la détection d'une collision avec la tête
        tout_lutins.add(anneau) #tous les lutins pour l'affichage
    
#-------Nos variables -------------    
arret = False
horloge = pygame.time.Clock()
anneau_L = 20
anneau_H = 20
anneau_E = 1   
dep_x = anneau_L+anneau_E
dep_y = 0
game_over = False
score = 0
#-------Créer une fenêtre ---------
pygame.init()
ecran = pygame.display.set_mode([ECRAN_L, ECRAN_H])
pygame.display.set_caption(" Snake pygame version 2")
#Chargement des images. 
#Le chargement des images ne peut se faire que lorsque la fenêtre est créée
tete_image = pygame.image.load("images/serpent_tete.png").convert_alpha()  
anneau_image = pygame.image.load("images/serpent_anneau.png").convert_alpha()
#-------Les listes de lutins -----------
#groupe de poussins pour la détection des collisions avec la tête
lesPoussins = pygame.sprite.Group()
#groupe des anneaux pour la détection des collisions avec la tête
lesAnneaux = pygame.sprite.Group()
#groupe de tous les lutins pour l'affichage
tout_lutins=pygame.sprite.Group()
#Création de la tête n'importe où sur la scène
tete = Bloc(random.randrange(0, ECRAN_H),random.randrange(0, ECRAN_L),tete_image)
tout_lutins.add(tete)
#liste des anneaux constituant la queue du serpent
queue=[]
#création des anneaux derrière la tête du serpent: ici 1 seul
creerAnneau(1,tete.rect.x,tete.rect.y)
#création des poussins
for i in range(15):
    poussin = Poussin()
    lesPoussins.add(poussin)
    tout_lutins.add(poussin)

#page d'instructions
font = pygame.font.SysFont("comicsansms", 40) 
#faut’il encore afficher une page
afficher_instructions = True
#numéro de la page à afficher
instruction_page = 1

# -------- Boucle d'affichage des premières pages -----------
while not arret and afficher_instructions:
    for event in pygame.event.get():
        #On laisse la possibilité au joueur d’arrêter le jeu tout de suite
        if event.type == pygame.QUIT:
            arret = True
        #un clic de souris incrémente le numéro de la page
        if event.type == pygame.MOUSEBUTTONDOWN:
            instruction_page += 1
            #si on a déjà affichér les deux premières pages
            #ilfaut sortir de cette boucle, pour lancer le jeu
            if instruction_page == 3:
                afficher_instructions = False
 
    # Mettre l'écran en noir pour écrire en blanc dessus
    ecran.fill(NOIR)
 
    if instruction_page == 1:
        # Les instructions sont écrites dans un fichier png
        # Ce fichier a été créé avec Paint.net 
        instruction_image = pygame.image.load("images\instructions.png").convert_alpha() 
        rectInstructions = instruction_image.get_rect()
        ecran.blit(instruction_image, rectInstructions)
    if instruction_page == 2:
        # Afficher la page 2 : texte constitué de 2 lignes
        #Première ligne
        texte_image = font.render("Attention ça va partir", True, BLANC)
        ecran.blit(texte_image, [150, 20])
        #Deuxième ligne
        texte_image = font.render("Cliquez pour démarrer", True, BLANC)
        ecran.blit(texte_image, [150, 100])
 
    # 60 images par seconde
    horloge.tick(60)
    # mise à jour de l'écran et retour en haut de la boucle
    pygame.display.flip()
    
#----Boucle principale ---------
while not arret:
    #boucle des évènements
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            arret = True
        if event.type == pygame.KEYDOWN:
            #le déplacement en x doit faire diminuer la valeur de x
            if event.key == pygame.K_LEFT:
                dep_x = (anneau_L + anneau_E) * -1
                dep_y = 0
            #le déplacement en x doit faire augmenter la valeur de x
            if event.key == pygame.K_RIGHT:
                dep_x = (anneau_L + anneau_E)
                dep_y = 0
            #le déplacement en y doit faire diminuer la valeur de y
            if event.key == pygame.K_UP:
                dep_x = 0
                dep_y = (anneau_H + anneau_E) * -1
            #le déplacement en y doit faire diminuer la valeur de y
            if event.key == pygame.K_DOWN:
                dep_x = 0
                dep_y = (anneau_H + anneau_E)
        
    if not game_over:
        #logique du jeu: calcul des nouvelles coordonnées tête
        #ancienne coordonnée de la tête
        x=tete.rect.x
        y = tete.rect.y
        #nouvelle coordonnée tete
        tete.rect.x+=dep_x
        tete.rect.y+=dep_y
        #faire réapparaitre le serpent de l'autre coté s'il atteint un bord
        if tete.rect.x > ECRAN_L:
            tete.rect.x = 0        
        if tete.rect.x < 0:
            tete.rect.x = ECRAN_L
        if tete.rect.y > ECRAN_H:
            tete.rect.y = 0
        if tete.rect.y < 0:
            tete.rect.y = ECRAN_H
        #Supprimer le dernier anneau du serpent
        dernier_anneau = queue.pop()
        #Enlever la référence de l'anneau supprimé dans les deux groupes où elle est mémorisée
        lesAnneaux.remove(dernier_anneau)
        tout_lutins.remove(dernier_anneau)
        #La tête est-elle entrée en collision avec un anneau.
        #nous plaçons ce teste ici, car la tête est pour l'instant bien séparée
        #de la queue, et nous ne risquons pas de fausse détection.
        collision_liste = pygame.sprite.spritecollide(tete,lesAnneaux,False)
        if len(collision_liste)> 0:
            game_over = True
        #créer un nouvel anneau et le mettre en tête de liste
        anneau=Bloc(x,y,anneau_image)
        queue.insert(0,anneau)
        #ajouter ce nouvel anneau dans les deux groupes qui le concerne
        lesAnneaux.add(anneau)
        tout_lutins.add(anneau)
        #La tête est t'elle entré en collision avec un poussin
        collision_liste = pygame.sprite.spritecollide(tete,lesPoussins,False)    
        #Tester la liste des collisions
        for poussin in collision_liste:
            #réinitialiser les positions des poussins touchés
            poussin.reset()
            #créer de nouveaux anneaux : ici 1 seul
            #queue[-1] donne la référence du dernier anneau de la liste
            creerAnneau(2,queue[-1].rect.x,queue[-1].rect.y)  
            score+=1
    
    	#Code traçant les objets du jeu
    	#commencer par effacer l’écran
        ecran.fill(BLANC)
        
        #afficher tous les lutins
        tout_lutins.draw(ecran)
        #Mettre l’écran à jour
        pygame.display.flip()
    	
    if game_over:
        # Mettre l'écran en noir pour écrire en blanc dessus
        ecran.fill(NOIR)
        texte_image = font.render("Game Over", True, BLANC)
        #Affichage de Game Over à peu près au centre de l’écran en x
        #et au tiers haut de l’écran en y
        text_rect = texte_image.get_rect()
        text_x = ecran.get_width() / 2 - text_rect.width / 2
        text_y = ecran.get_height() / 3 - text_rect.height / 3
        #Affichage d’une deuxième ligne de texte en dessous de Game Over
        ecran.blit(texte_image, [text_x, text_y])
        texte_image = font.render("Le serpent s'est mordu la queue", True, BLANC)
        ecran.blit(texte_image, [50, text_y + 50])
        #Affichage d’une troisième ligne avec le score
        leScore = "Score : " + str(score)
        texte_image = font.render(leScore, True, BLANC)
        ecran.blit(texte_image, [text_x, text_y + 100])
        #Mettre l’écran à jour
        pygame.display.flip()
        
	#Mise à jour de l’écran à raison de 10 images/seconde
    horloge.tick(10)
        
pygame.quit()

